## icewm 3.7.4

=== po/CMakeLists.txt ===
#
# Custom PO file processing (POT extraction/update, PO merging, MO building).
#
# Callable custom targets (part of ALL target):
#
# The default rule set updates pot, *.po, and compiles *.(g)mo from the updated
# versions. Also some CACHED options:
# - with PO_REPLACE options, the updated files are sync'ed back to source code
#   folder in the build phase.
# - with PO_REPLACE_ONCE the original PO/POT files are replaced once and then
#   not again (cached)
# - with SKIP_TRANSLATIONS, the whole PO processing is turned off and MO files
#   are NOT installed. This might be handy in the development process.
#
# when gettext tools are missing, no processing is performed.
#

option(SKIP_TRANSLATIONS "[DEV] Don't perform PO/MO file creation or installation" off)
option(PO_VERBOSE "[DEV] Extra verbosity in gettext processing (extends EXTRA_MSGMERGE and EXTRA_MSGMERGE)" off)
option(PO_REPLACE "[DEV] Install updated POT/PO files in source folder" off)
option(PO_REPLACE_ONCE "[DEV] Like PO_REPLACE but turns itself off after one run" off)

if(SKIP_TRANSLATIONS)
    message(STATUS "Language file processing disabled by SKIP_TRANSLATIONS option")
    return()
endif()

if(PO_VERBOSE)
    list(APPEND EXTRA_MSGMERGE --verbose)
    list(APPEND EXTRA_MSGFMT --verbose)
else()
    list(APPEND EXTRA_MSGMERGE --quiet)
endif()

#
# NOTE: FindGettext.cmake exists but it's not really handy :-(
#
find_program(gettext gettext)
find_program(xgettext xgettext)
find_program(msgmerge msgmerge)
find_program(msgfmt msgfmt)

set(COPYRIGHT_HOLDER "Marko Macek <Marko.Macek@gmx.net>")
set(BUG_ADDRESS "https://github.com/bbidulock/icewm/issues")

if(NOT gettext OR NOT xgettext OR NOT msgmerge OR NOT msgfmt)
    message(STATUS "Some of those tools not found, skipping translations! gettext, xgettext, msgmerge, msgfmt")
    return()
endif()

set(_potFilePublic "${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE}.pot")
set(_potFile "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}.pot")
set(_potFileStamp "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}.pot.stamp")

# NOTE: xgettext uses the -f option (and started from project dir so that
# unwanted path information is not leaked) but we also want to track the file
# dependencies, thus building the list here explicitly.
file (STRINGS "POTFILES.in" SRCS_IN)
set(SRCS)
foreach(_src ${SRCS_IN})
    LIST(APPEND SRCS "${CMAKE_SOURCE_DIR}/${_src}")
endforeach()

file (STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS" LANGUAGES)

set(XGETTEXT_CMD xgettext -f po/POTFILES.in --from-code=UTF-8 -language=CXX --add-comments=TRANSLATORS: --keyword=_ --keyword=N_  --package-name=${PACKAGE} --copyright-holder="${COPYRIGHT_HOLDER}"  --package-version="${VERSION}" --msgid-bugs-address="${BUG_ADDRESS}" -o "${_potFile}" )

if(PO_REPLACE OR PO_REPLACE_ONCE)
    set(SRC_UPDATE COMMAND ${CMAKE_COMMAND} -E copy_if_different "${_potFile}" "${_potFilePublic}")
else()
    set(SRC_UPDATE )
endif()

add_custom_command(OUTPUT "${_potFileStamp}"
    DEPENDS ${SRCS}
    BYPRODUCTS "${_potFile}"
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
    VERBATIM

    COMMAND ${XGETTEXT_CMD}

    ${SRC_UPDATE}

    COMMAND ${CMAKE_COMMAND} -E touch "${_potFileStamp}"

    COMMENT "Extracting translatable messages")

add_custom_target(update_pot DEPENDS "${_potFileStamp}")
#message(VERBOSE "Adding non-default update_pot target to update ${_potFile}")

add_custom_target(translations ALL)

foreach(_lang ${LANGUAGES})
    set(_tempPO "${CMAKE_CURRENT_BINARY_DIR}/${_lang}.po")
    set(_srcPO "${CMAKE_CURRENT_SOURCE_DIR}/${_lang}.po")
    message(VERBOSE "Generating updated ${_tempPO} from ${_srcPO}")
    add_custom_command(OUTPUT ${_tempPO}
        COMMAND msgmerge -o "${_tempPO}" ${EXTRA_MSGMERGE} -s "${_srcPO}" "${_potFile}"
        #WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${_lang}.po" "${_potFile}" update_pot
        #COMMENT "Updated: ${_tempPO}"
        VERBATIM)
    add_custom_target(generate-${_lang}.po DEPENDS ${_tempPO} ALL)

    if(PO_REPLACE OR PO_REPLACE_ONCE)
        set(SRC_UPDATE COMMAND ${CMAKE_COMMAND} -E copy_if_different "${_tempPO}" "${_srcPO}")
        message(STATUS "Shall replace: ${_srcPO}")
    else()
        set(SRC_UPDATE )
    endif()

    set(_tempMO "${CMAKE_CURRENT_BINARY_DIR}/${_lang}.gmo")
    add_custom_command(OUTPUT "${_tempMO}"
        COMMAND msgfmt -o ${_tempMO} ${EXTRA_MSGFMT} ${_tempPO}
        ${SRC_UPDATE}
        DEPENDS ${_tempPO}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        VERBATIM)
    add_custom_target(generate-${_lang}.gmo DEPENDS ${_tempMO})
    add_dependencies(translations generate-${_lang}.gmo)

    # Install user products
    install(FILES ${_tempMO} DESTINATION "${LOCDIR}/${_lang}/LC_MESSAGES/" RENAME "${PACKAGE}.mo" OPTIONAL)

    # mimic the content of the installation folder, for development purposes
    set(PG "${CMAKE_CURRENT_BINARY_DIR}/playground")
    file(MAKE_DIRECTORY "${PG}")
    file(MAKE_DIRECTORY "${PG}/${_lang}/LC_MESSAGES/")
    if(CMAKE_VERSION VERSION_GREATER OR  VERSION_EQUAL "3.14")
        file(CREATE_LINK ${_tempMO} "${PG}/${_lang}/LC_MESSAGES/${PACKAGE}.mo" SYMBOLIC)
    else()
        install(FILES ${_tempMO} DESTINATION "${PG}/${_lang}/LC_MESSAGES/" RENAME "${PACKAGE}.mo" OPTIONAL)
    endif()

endforeach()

if(PO_REPLACE_ONCE)
    unset(PO_REPLACE)
    unset(PO_REPLACE_ONCE)
    unset(PO_REPLACE CACHE)
    unset(PO_REPLACE_ONCE CACHE)
endif()

# vim: ts=4 shiftwidth=4 et

=== src/CMakeLists.txt ===

# to use target_link_options
cmake_minimum_required(VERSION 3.5)

PROJECT(ICEWM CXX)

# Do not fail (because we are still C++11 compliant), try to continue anyway
# with -std=c++11.
set(CMAKE_CXX_STANDARD_REQUIRED off)
# Actually try to use C++20 as well where possible, to uncover potential issues.
if(CMAKE_VERSION VERSION_GREATER OR VERSION_EQUAL "3.20")
    set(CMAKE_CXX_STANDARD 20)
else()
    set(CMAKE_CXX_STANDARD 14)
endif()



INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckTypeSize)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(FindPkgConfig)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckCXXCompilerFlag)

SET(CXXFLAGS_COMMON -pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -DHAVE_CONFIG_H -include "${CMAKE_BINARY_DIR}/config.h")
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

unset(icewm_libs)
unset(Intl_INCLUDE_DIRS)

macro(concat_dedup _result_var)
    set(${_result_var} ${ARGN})
    list(REMOVE_DUPLICATES ${_result_var})
endmacro()

option(AUTO_INC_HEADERS "Guess related headers and include in the build config (developer comfort feature)" off)
macro(do_auto_inc_headers _in_out_var)
    if(AUTO_INC_HEADERS)
        set(auto_inc_headers_tmp)
        foreach(src ${${_in_out_var}})
            list(APPEND auto_inc_headers_tmp ${src})
            cmake_path(REPLACE_EXTENSION src .h OUTPUT_VARIABLE h_cand)
            message("Looking for ${h_cand}")
            if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${h_cand}")
                list(APPEND auto_inc_headers_tmp "${h_cand}")
            endif()
        endforeach()
        list(REMOVE_DUPLICATES auto_inc_headers_tmp)
        set(${_in_out_var} ${auto_inc_headers_tmp})
    endif()
endmacro()

macro(pkg_check_or_fail _prefix _what)
    clear_pkg_config(${_prefix})
    pkg_check_modules(${_prefix} ${_what})
    if(NOT ${_prefix}_FOUND)
        message(FATAL_ERROR ${ARGN})
    endif()
endmacro()

# drop remainings variables of pkg_config's work from the current scope
macro(clear_pkg_config _prefix)
    foreach(_i "_LIBRARIES" "_LINK_LIBRARIES" "_LIBRARY_DIRS" "_LDFLAGS" "_LDFLAGS_OTHER" "_INCLUDE_DIRS" "_CFLAGS" "_CFLAGS_OTHER")
        unset("${_prefix}${_i}")
    endforeach()
endmacro()

# optimize for release if not defined explicitly, can be overriden with CMAKE_BUILD_TYPE "None"
if("${CMAKE_BUILD_TYPE}" STREQUAL "" AND ("" STREQUAL "${CMAKE_CXX_FLAGS}"))
    SET(CMAKE_BUILD_TYPE Release)
endif()

# I don't need -rdynamic, thanks!
SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")

SET(CMAKE_REQUIRED_FLAGS )

CHECK_CXX_COMPILER_FLAG(-fvisibility=hidden CXX_VHI)
if(CXX_VHI)
    list(APPEND CXXFLAGS_COMMON -fvisibility=hidden)
endif()

CHECK_CXX_COMPILER_FLAG(-fvisibility-inlines-hidden CXX_VIHI)
if(CXX_VIHI)
    list(APPEND CXXFLAGS_COMMON -fvisibility-inlines-hidden)
endif()

# teach GCC7+ to interpret our comments
CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough=2 HAS_FALLTHROUGH_OPTION)
if(HAS_FALLTHROUGH_OPTION)
    list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough=2)
else()
    CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough HAS_FALLTHROUGH_OPTION)
    if(HAS_FALLTHROUGH_OPTION)
        list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough)
    endif()
endif()

#list(APPEND CXXFLAGS_COMMON    -fsanitize=address -fsanitize=undefined)
#list(APPEND EXTRA_LINKER_FLAGS -fsanitize=address -fsanitize=undefined)

option(CONFIG_IMLIB2 "Imlib2 image loader" on)
option(CONFIG_LIBPNG "PNGLIB image loader" off)
option(CONFIG_LIBJPEG "JPEGLIB image loader" off)
option(CONFIG_GDK_PIXBUF_XLIB "GDK-PIXBUF image loader" off)
option(CONFIG_LIBRSVG "Support SVG icons using librsvg" off)
option(CONFIG_NANOSVG "Support SVG icons using nanosvg" off)
option(CONFIG_XPM "XPM image loader" on)
option(CONFIG_I18N "Define to enable internationalization" on)
option(CONFIG_XRANDR "Define to enable XRANDR extension" on)
option(CONFIG_SESSION "Define to enable X session management" on)
option(CONFIG_EXTERNAL_TRAY "Define for external systray (deprecated)" off)
option(ENABLE_NLS "Enable Native Language Support" on)
option(ENABLE_LTO "Enable Link Time Optimization" off)
option(ENABLE_LOGEVENTS "Enable logging of X11 events" off)

set(LOGEVENTS ${ENABLE_LOGEVENTS})
SET(CONFIG_DEFAULT_THEME "icedesert/default.theme" CACHE STRING "Name of default theme")
SET(CONFIG_DEFAULT_BACKGROUND "" CACHE STRING "Default background image or directory")
SET(CONFIG_UNICODE_SET "" CACHE STRING "Your iconv unicode set in machine endian encoding (e.g. WCHAR_T, UCS-4-INTERNAL, UCS-4LE, UCS-4BE)")
# turn off when empty, see config.h template for details
IF("" STREQUAL "${CONFIG_UNICODE_SET}")
    SET(CONFIG_UNICODE_SET OFF)
ELSE()
    MESSAGE(STATUS "Configured custom unicode set: ${CONFIG_UNICODE_SET}.")
ENDIF()
SET(XTERMCMD xterm CACHE STRING "Default terminal emulator for X11")

if(ENABLE_NLS OR CONFIG_I18N)
    find_library(CONFIG_LIBICONV iconv)
    if(CONFIG_LIBICONV)
        LIST(APPEND nls_LIBS iconv)
    endif()
    find_package(Intl)
    if(CMAKE_VERSION VERSION_GREATER OR  VERSION_EQUAL "3.20")
        list(APPEND nls_LIBS Intl::Intl)
    else()
        if(Intl_FOUND)
            list(APPEND nls_LIBS ${Intl_LIBRARIES})
        endif()
    endif()
endif()

if(ENABLE_LTO AND ${CMAKE_HOST_SYSTEM_NAME} MATCHES "Linux")
    # https://stackoverflow.com/questions/72218980/gcc-v12-1-warning-about-serial-compilation
    check_cxx_compiler_flag(-flto=auto USE_LTOAUTO)
    if(USE_LTOAUTO)
        list(APPEND CXXFLAGS_COMMON -flto=auto)
    else()
        list(APPEND CXXFLAGS_COMMON -flto)
    endif()
endif()

# the only used ones...
# for x in `cat funclist` ; do grep $x src/* lib/* && echo $x >> exlist ; done
# perl -e 'print "CHECK_FUNCTION_EXISTS($_ HAVE_".uc($_).")\n" for @ARGV' `cat exlist`
# perl -e 'print "#cmakedefine HAVE_".uc($_)."\n" for @ARGV' `cat exlist`
CHECK_FUNCTION_EXISTS(backtrace_symbols_fd HAVE_BACKTRACE_SYMBOLS_FD)
CHECK_FUNCTION_EXISTS(memrchr HAVE_MEMRCHR)
CHECK_FUNCTION_EXISTS(strlcat HAVE_STRLCAT)
CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
CHECK_FUNCTION_EXISTS(sysctl HAVE_SYSCTL)
CHECK_FUNCTION_EXISTS(sysctlbyname HAVE_SYSCTLBYNAME)

# perl -e 'do { s/\.|\//_/g; $_=uc $_;  print "#cmakedefine HAVE_$_\n"} for @ARGV' `cat headersDa`
# perl -e 'do {my $orig=$_; s/\.|\//_/g; $_=uc $_; print "CHECK_INCLUDE_FILE_CXX($orig HAVE_$_)\n"} for @ARGV' `cat headersDa`
CHECK_INCLUDE_FILE_CXX(execinfo.h HAVE_EXECINFO_H)
CHECK_INCLUDE_FILE_CXX(sched.h HAVE_SCHED_H)
CHECK_INCLUDE_FILE_CXX(sys/sched.h HAVE_SYS_SCHED_H "-include /usr/include/sched.h")
CHECK_INCLUDE_FILE_CXX(sys/sysctl.h HAVE_SYS_SYSCTL_H "-include /usr/include/sys/types.h")
CHECK_INCLUDE_FILE_CXX(uvm/uvm_param.h HAVE_UVM_UVM_PARAM_H)

#########################################################
# fiting flags to options and available system features #
#########################################################

pkg_check_modules(fontconfig fontconfig)
pkg_check_modules(xrender REQUIRED xrender)
pkg_check_modules(xcomposite REQUIRED xcomposite)
pkg_check_modules(xdamage REQUIRED xdamage)
pkg_check_modules(xfixes REQUIRED xfixes)
pkg_check_modules(xext REQUIRED xext)
pkg_check_modules(x11 REQUIRED x11)

CHECK_LIBRARY_EXISTS(X11 XInternAtoms ${x11_LIBDIR} HAVE_XINTERNATOMS)

set(icewm_img_libs ${xrender_LDFLAGS} ${xcomposite_LDFLAGS} ${xdamage_LDFLAGS} ${xfixes_LDFLAGS})

# It would be a good idea to use different names for the image options and do the
# logics here.  For now, this self-adapting code modifies the option variables.

set(HINT_CURSORS
[=[
 Cursor support requires either -DCONFIG_XPM=on or -DCONFIG_IMLIB2=on.
]=])

set(HINT_IMG_LOADERS
[=[
 There is a choice to be made between two image loaders.
 Either 'yimage_gdk' must be enabled by -DCONFIG_GDK_PIXBUF_XLIB=on,
 or 'imlib2' must be enabled by -DCONFIG_IMLIB2=on,
 or else 'yximage' must be enabled by -DCONFIG_LIBPNG=on.
 The latter requires -DCONFIG_XPM=on, while -DCONFIG_LIBJPEG=on is recommended.
 Support SVG icons with either -DCONFIG_LIBRSVG=on or -DCONFIG_NANOSVG=on.
 ]=] ${HINT_CURSORS})

# image configuration error check
if(CONFIG_IMLIB2 OR CONFIG_GDK_PIXBUF_XLIB)
    if (NOT CONFIG_LIBRSVG AND NOT CONFIG_NANOSVG)
        # ok
    endif()
elseif(CONFIG_XPM AND CONFIG_LIBPNG)
    if (NOT CONFIG_LIBJPEG)
        message(WARNING "LIBJPEG is advisable for backgrounds in icewmbg")
    endif()
    set(CONFIG_LIBRSVG off)
    set(CONFIG_NANOSVG off)
else()
    MESSAGE(FATAL_ERROR ${HINT_IMG_LOADERS})
endif()

if(CONFIG_IMLIB2)
    pkg_check_or_fail(libimlib2 imlib2 "IMLIB2 selected but Imlib2 dev files not found.")
    set(CONFIG_GDK_PIXBUF_XLIB off)
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    LIST(APPEND icewm_img_libs ${libimlib2_LDFLAGS})
endif()

if(CONFIG_GDK_PIXBUF_XLIB)
    pkg_check_or_fail(pixbuf gdk-pixbuf-xlib-2.0
        "GDX-PIXBUF image loader selected but its dev files were not found."
        ${HINT_IMG_LOADERS})
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    LIST(APPEND icewm_img_libs ${pixbuf_LDFLAGS})
endif()

# this is a) optional, b) loaded through pixbuf anyway
if (CONFIG_LIBRSVG)
    pkg_check_modules(librsvg librsvg-2.0)
    if(NOT librsvg_FOUND)
        message(WARNING
                "SVG image loader selected but librsvg-2.0 dev files not found."
                "SVG support will not be available.")
        set(CONFIG_LIBRSVG off)
    else()
        LIST(APPEND icewm_img_libs ${librsvg_LDFLAGS})
        set(CONFIG_NANOSVG off)
    endif()
endif()

if (CONFIG_NANOSVG)
    if(NOT NANOSVG_DIR)
        set(NANOSVG_DIR ${CMAKE_SOURCE_DIR}/src)
    endif()
    include_directories(${NANOSVG_DIR})
    set(hub https://raw.githubusercontent.com/memononen/nanosvg/master/src)
    foreach(nano nanosvg.h nanosvgrast.h)
        message(STATUS "Checking for ${NANOSVG_DIR}/${nano}")
        set(src "${NANOSVG_DIR}/${nano}")
        if (NOT EXISTS ${src})
            set(url ${hub}/${nano})
            file(DOWNLOAD ${url} ${src} INACTIVITY_TIMEOUT 3 STATUS down)
            list(GET down 0 stat)
            list(GET down 1 mesg)
            if(NOT ${stat} EQUAL 0 OR NOT EXISTS ${src})
                message(WARNING "Cannot download ${url} to ${src}: ${mesg}")
                set(CONFIG_NANOSVG off)
                break()
            endif()
        endif()
    endforeach()
endif()

# cursor configuration error check
if(CONFIG_XPM)
    #ok
elseif(CONFIG_IMLIB2)
    #ok
else()
    MESSAGE(FATAL_ERROR ${HINT_CURSORS})
endif()

if(CONFIG_XPM)
    pkg_check_or_fail(libxpm xpm "XPM image loader selected but libXpm dev files not found."
        ${HINT_IMG_LOADERS})
    LIST(APPEND icewm_img_libs ${libxpm_LDFLAGS})
endif()

if(CONFIG_LIBPNG)
    pkg_check_or_fail(libpng libpng "PNG image loader selected but libpng dev files not found."
        ${HINT_IMG_LOADERS})
    LIST(APPEND icewm_img_libs ${libpng_LDFLAGS})
endif()

if(CONFIG_LIBJPEG)
    pkg_check_or_fail(libjpeg libjpeg "JPEG image loader selected but libjpeg dev files not found."
        "Please install libjpeg-dev (or similar)."
        "Otherwise use -DCONFIG_LIBJPEG=off.")
    LIST(APPEND icewm_img_libs ${libjpeg_LDFLAGS})
endif()

IF(CONFIG_SESSION)
    LIST(APPEND sm_LIBS SM ICE)
ENDIF()

option(CONFIG_SHAPE "Define to enable transparent frame	decoration (titlebar borders), requests X shape extension." on)
# TODO: check the symbol: AC_CHECK_LIB([Xext],[XShapeCombineRectangles],
if(CONFIG_SHAPE AND NOT xext_FOUND)
    message(WARNING "Xext library not found, disabling CONFIG_SHAPE")
    set(CONFIG_SHAPE off)
endif()

if(CONFIG_XRANDR)
    pkg_check_modules(xrandr xrandr)
    IF(NOT xrandr_FOUND)
        message(WARNING "Xrandr library not found, disabling CONFIG_XRANDR")
        set(CONFIG_XRANDR off)
    ENDIF()
endif()

option(HAVE_XRES "Define to enable XRes support" on)
if(HAVE_XRES)
    pkg_check_modules(xres xres>=1.2)
    IF(NOT xres_FOUND)

=== debian/changelog ===
icewm (3.7.4-1) unstable; urgency=medium

  * New upstream release
    + cherry-picked fixes of https://github.com/bbidulock/icewm/issues/800
      (3.7.4..4603a667999d81b2e88a51dedd1b9e761d384b74)
  * Stop building additional test executables (closes: Bug#1103314)

 -- Eduard Bloch <blade@debian.org>  Sat, 03 May 2025 14:48:22 +0200

=== debian/control ===
Source: icewm
Section: x11
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>= 10),
# misc. build tools
  gettext,
  pandoc (>> 2),
  cmake (>> 3.12),
  asciidoctor,
  dpkg-dev (>= 1.16.1~),
# sound libs
  libsndfile1-dev,
  libao-dev,
# image loaders
  libimlib2-dev,
  libnanosvg-dev,
# font processor(s)
  libxft-dev (>> 2.1.1) | libxft2-dev,
# X11 libs
  x11proto-core-dev | x-dev,
  libsm-dev,
  libx11-dev,
  libxext-dev,
  libxinerama-dev,
  libxrender-dev,
  libxrandr-dev,
  libfribidi-dev,
  libxcomposite-dev,
  libxdamage-dev,
Build-Conflicts: libttf-dev, libesd0-dev
Standards-Version: 4.5.0
Vcs-Git: https://github.com/Code7R/icewm.git

Package: icewm-common
Architecture: any
Conflicts: menu (<< 2.1.9-1)
Replaces: icewm (<< 1.2.14), icewm-gnome-support (<< 1.3.8-3), icewm-themes (<< 1.3.8-3)
Depends: ${misc:Depends}, ${shlibs:Depends}, sensible-utils
Recommends: xscreensaver, lxqt-menu-data | gnome-menus | lxmenu-data, desktop-base
Suggests: menu, extra-xdg-menus, xterm
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. Can emulate the look of
 Windows'95, OS/2 Warp 3,4, Motif. Tries to take the best features of the above
 systems.
 Features multiple workspaces, opaque move/resize, task bar, window list,
 mailbox status, digital clock. Fast and small.
 .
 This package provides the common files for icewm, icewm-experimental and
 icewm-lite binary packages.

Package: icewm
Architecture: any
Depends: icewm-common (= ${binary:Version}), ${shlibs:Depends},
  fonts-dejavu-core | custom-icewm-font,
  fonts-dejavu-mono | custom-icewm-font,
  sensible-utils,
  ${misc:Depends}
Conflicts: icewm-common (<< 1.3.8-3)
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, digital clock.

Package: icewm-lite
Architecture: any
Depends: icewm (= ${binary:Version}), icewm-common (= ${binary:Version}), ${misc:Depends}
Section: oldlibs
Description: transitional package for icewm
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides different looks and some desktop-like
 functionality.
 .
 This package only exists to maintain compatibility to system setups that
 relied on the former icewm-lite package. It can be safely removed once the
 system dependencies has been adjusted.

Package: icewm-experimental
Architecture: any
Depends: icewm (= ${binary:Version}), icewm-common (= ${binary:Version}), ${misc:Depends}
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, digital clock.
 .
 This package sometimes provides special IceWm versions with experimental
 features enabled. When the configurations of the packages do not diverge
 it simply enforces an upgrade to the current icewm package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for icewm

UPSTREAM_BRANCH=icewm-1-4-BRANCH
ICEWM_COMMON=$(CURDIR)/debian/icewm-common
ICEWM=$(CURDIR)/debian/icewm
ICEWM_LITE=$(CURDIR)/debian/icewm-lite
ICEWM_EXP=$(CURDIR)/debian/icewm-experimental
DOCDIR=/usr/share/doc/icewm-common
BDIR=builddir
ICONS=$(CURDIR)/debian/icons
FDO=$(CURDIR)/debian/fdo
CUSTOM=$(CURDIR)/debian/custom
cmakeargs = -DDOCDIR=$(DOCDIR) -DHTMLDIR=$(DOCDIR)/html \
						-DVERSION=$(ORIGVERSION) \
						-DICEHELPIDX=/usr/share/doc/icewm-common/html/icewm.html \
						-DCFGDIR=/etc/X11/icewm \
						-DCMAKE_INSTALL_PREFIX=/usr \
						-DCMAKE_VERBOSE_MAKEFILE=ON \
						-DICESOUND=AO -DCONFIG_IMLIB2=on \
						-DCONFIG_NANOSVG=on \
						-DNANOSVG_DIR=/usr/include/nanosvg \
						-DCONFIG_XPM=off \
						-DCONFIG_LIBJPEG=off \
						-DCONFIG_LIBPNG=off \
						-DCONFIG_GDK_PIXBUF_XLIB=off \
						-DXTERMCMD=x-terminal-emulator
#-DEXTRA_LIBS="-lsupc++" 
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
-include /usr/share/quilt/quilt.make

CXXFLAGS += $(CPPFLAGS) -DXTERMCMD=x-terminal-emulator -Wall -Wextra
ifeq (linux,$(DEB_TARGET_ARCH_OS))
	 CXXFLAGS += -DUSE_SIGNALFD
endif

%:
	dh $@ -Scmake

# DEBVERSION=$(shell dpkg-parsechangelog -SVersion)
# that one also works with wheezy
DEBVERSION := $(shell dpkg-parsechangelog |grep ^Version | sed -e s,Version:.,,)
ORIGVERSION := $(shell echo $(DEBVERSION) | sed -e 's,-[^-]*$$,,' )
ORIGTAG := upstream/$(shell echo $(ORIGVERSION) | sed -e 's,~,,g' )

# dh_auto_build is no help here...
PAROPT=$(shell echo $$DEB_BUILD_OPTIONS | sed -e 's,.*parallel=\([0-9]\).*,-j\1,')

#build_lite:
#	$(MAKE) $(PAROPT) -C $(BDIR)-lite
#
#build_normal:
#	$(MAKE) $(PAROPT) -C $(BDIR)-normal

#config_lite:
#	mkdir -p $(BDIR)-lite
#	# this fails on prefering cmake :-( dh_auto_configure --builddirectory=$(BDIR)-lite -- 
#	cd $(BDIR)-lite && cmake .. -DCMAKE_BUILD_TYPE=None $(cmakeargs) -DLITE=on -DEXEEXT=-lite -DCONFIG_XFREETYPE=off -DCONFIG_COREFONTS=on -DXINERAMA=on -DCONFIG_XRANDR=off -DCONFIG_TASKBAR=off -DCONFIG_FDO_MENUS=off -DSKIP_TRANSLATIONS=on -DICESOUND=off
#
#config_normal:
#	mkdir -p $(BDIR)-normal
#	cd $(BDIR)-normal && cmake .. -DCMAKE_BUILD_TYPE=None $(cmakeargs) -DCONFIG_XRANDR=on -DCONFIG_GUIEVENTS=on

override_dh_auto_configure:
	dh_auto_configure -- $(cmakeargs)

override_dh_autoreconf:
	true

override_dh_auto_test:
	true

#override_dh_auto_configure:
#	$(MAKE) -f debian/rules -j2 config_normal config_lite

#override_dh_auto_build:
# strtest is not part of the 'all' targets, and also requires BUILD_TESTING option
#	dh_auto_build -- all strtest
#	cd debian && for x in -lite -experimental ; do cp -lf icewm.postinst icewm$$x.postinst ; cp -lf icewm.prerm icewm$$x.prerm ; done

#override_dh_auto_install:
#	$(MAKE) -C $(BDIR)-lite install DESTDIR=$(CURDIR)/debian/tmp
#	$(MAKE) -C $(BDIR)-normal install DESTDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install
	cd debian && for x in -lite -experimental ; do cp -lf icewm.postinst icewm$$x.postinst ; cp -lf icewm.prerm icewm$$x.prerm ; done
	# XXX: find out why some settings are not gettint defaults if the file is not present, like WorkspaceNames
	#cp $(ICEWM_COMMON)/usr/share/doc/icewm-common/preferences $(ICEWM_COMMON)/usr/share/icewm/
	# Install Debian custom files
	install -m 644 $(ICONS)/mutt*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	install -m 644 $(ICONS)/mozilla*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	install -m 644 $(ICONS)/icewm*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	-mv $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.xpm  $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.orig.xpm
	install -m 644 $(ICONS)/debian.xpm $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.xpm
	mkdir -p $(ICEWM_COMMON)/usr/bin $(ICEWM_COMMON)/etc/X11/icewm
	install -m 644 $(CUSTOM)/toolbar $(CUSTOM)/menu $(ICEWM_COMMON)/usr/share/icewm
	install -m 644 debian/README.cfg $(ICEWM_COMMON)/usr/share/icewm/README
	install -m 755 debian/netstat.sh $(ICEWM_COMMON)/usr/share/icewm
	# Extra docs
	mkdir -p "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ"
	pandoc $(CURDIR)/debian/FAQ/source/index.md -o "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ/IceWM-FAQ.html"
	pandoc -t asciidoc $(CURDIR)/debian/FAQ/source/index.md -o "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ/IceWM-FAQ.txt"
	cd debian ; for x in icewm icewm-lite icewm-experimental ; do mkdir -p $$x/usr/share/lintian/overrides ; cp $$x.lintian $$x/usr/share/lintian/overrides/$$x ; done	
	sed -e 's,^.link.*fonts.googleapis.*,,' -i "$(ICEWM_COMMON)/usr/share/doc/icewm-common/html/"*.html
	dh_link -A

override_dh_auto_clean:
	rm -rf $(BDIR)-lite $(BDIR)-normal IceWM-FAQ.txt configure.in
	# the variants are just symlinks
	rm -f debian/icewm-*.postinst debian/icewm-*.prerm
	dh_auto_clean

override_dh_installchangelogs:
	cat ChangeLog CHANGES > debian/changelog.mix
	dh_installchangelogs -picewm-common debian/changelog.mix

override_dh_fixperms:
	dh_fixperms
	chmod a+rx,u+w "$(ICEWM_COMMON)/usr/share/doc/icewm-common/examples/startup"

override_dh_compress:
	dh_compress

cleancruft:
	git clean -fdx -e .cproject -e .project -e .settings
	git checkout HEAD -- README.md configure.ac configure.in ChangeLog

set-orig-snapshot:
	lc=$$(git reflog $(UPSTREAM_BRANCH) | head -n1 | cut -f1 -d" ") && dd=$$(date +\%Y\%m\%d) && ov=$$(dpkg-parsechangelog -S Version) && pfx=$$(echo $$ov | sed -e 's,mod.*,mod,') && echo $$lc $$dd $$ov $$pfx && dch --newversion $$pfx+$$dd+$$lc-1

# builds a snapshot of the upstream branch after some plausibility checks
get-orig-source:
	! test -e ../icewm_$(ORIGVERSION).orig.tar.xz || (echo Target already exists ; exit 1)
# little canary to prevent forgotten updates - however, not applied for upstream tags
	if ! test -e .git/refs/tags/$(UPSTREAM_BRANCH) ; then \
		lc=`git reflog $(UPSTREAM_BRANCH) | head -n1 | cut -f1 -d" "` \
		&& echo "Expected upstream ref: $$lc (on failure run update-debian-mod target)" \
		&& grep -m1 ^commit ChangeLog | grep "$$lc" \
	;fi
	git tag $(ORIGTAG) $(UPSTREAM_BRANCH)
	git archive $(ORIGTAG) --prefix icewm-$(ORIGVERSION)/ | xz -9 > ../icewm_$(ORIGVERSION).orig.tar.xz
	test -d ../tarballs && ln ../icewm_$(ORIGVERSION).orig.tar.xz ../tarballs || true
	pristine-tar commit ../icewm_$(ORIGVERSION).orig.tar.xz $(ORIGTAG)

update-debian-mod:
	grep debian .git/HEAD
	set -x && (echo -e "# created with git log --stat=76 -M -C -500|fmt -sct -w80\n" ; \
		  git log $(UPSTREAM_BRANCH) --stat=76 -M -C -500|fmt -sct -w80 \
		)|head -10000 > ChangeLog
	git commit ChangeLog -m "Updating ChangeLog for a new Debian snapshot"

## icewm 3.7.5

=== debian/changelog ===
icewm (3.7.5-1) unstable; urgency=medium

  * New upstream release
  * Added libxres-dev build-dep to support XResClientIdsDestroy

 -- Eduard Bloch <blade@debian.org>  Wed, 28 May 2025 21:43:03 +0200

## icewm 3.8.0

=== debian/changelog ===
icewm (3.8.0-1.0antix1) unstable; urgency=medium

  * upstream bugfixes and enhancements
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 23 Jun 2025 17:16:28 +0300

icewm (3.7.5-1.0antix1) unstable; urgency=medium

  * upstream bugfixes and enhancements
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 26 May 2025 17:11:49 +0300

icewm (3.7.4-1.0antix1) unstable; urgency=medium

  * upstream bugfixes and enhancements
  * antiX build

 -- anticapitalista <antix@operamail.com>  Wed, 23 Apr 2025 22:33:51 +0300

icewm (3.7.3-1.0antix1) unstable; urgency=medium

  * upstream bugfixes and enhancements
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 31 Mar 2025 14:03:34 +0300

icewm (3.7.2-1.0antix1) unstable; urgency=medium

  * upstream bugfixes and enhancements
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 10 Mar 2025 00:24:40 +0200

## icewm 3.8.1

=== debian/changelog ===
icewm (3.8.1-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 20 Jul 2025 14:20:43 +0200

=== debian/control ===
--- 
+++ 
@@ -28,6 +28,7 @@
   libfribidi-dev,
   libxcomposite-dev,
   libxdamage-dev,
+  libxres-dev
 Build-Conflicts: libttf-dev, libesd0-dev
 Standards-Version: 4.5.0
 Vcs-Git: https://github.com/Code7R/icewm.git

=== debian/rules ===
--- 
+++ 
@@ -31,7 +31,6 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/architecture.mk
--include /usr/share/quilt/quilt.make
 
 CXXFLAGS += $(CPPFLAGS) -DXTERMCMD=x-terminal-emulator -Wall -Wextra
 ifeq (linux,$(DEB_TARGET_ARCH_OS))

## icewm 3.8.2

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
PROJECT(ICEWM CXX)

#
# Which themes to install in alphabetical order
#
set(themesList CrystalBlue Helix Infadel2 NanoBlue
    default icedesert metal2 motif win95)

foreach(_src keys menu programs toolbar winoptions IceWM.jpg)
    set(_pre "${CMAKE_CURRENT_SOURCE_DIR}/${_src}.in")
    if(EXISTS "${_pre}")
        CONFIGURE_FILE("${_pre}" "${CMAKE_CURRENT_BINARY_DIR}/${_src}")
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${_src}"
                DESTINATION "${LIBDIR}")
    else()
        install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/${_src}"
                DESTINATION "${LIBDIR}")
    endif()
endforeach()

foreach (dtop icewm.desktop icewm-session.desktop)
    FILE(READ ${CMAKE_CURRENT_SOURCE_DIR}/${dtop} text)
    STRING(REGEX REPLACE "Exec=/[a-z/]*/" "Exec=${BINDIR}/" text "${text}")
    FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/${dtop} "${text}")
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${dtop} DESTINATION "${DATADIR}/xsessions/")
endforeach()

install(DIRECTORY mailbox taskbar icons ledclock
        DESTINATION "${LIBDIR}"
        FILES_MATCHING PATTERN "*"
        PATTERN "*.in" EXCLUDE)

foreach(theme ${themesList})
    install(DIRECTORY "themes/${theme}"
            DESTINATION "${LIBDIR}/themes")
endforeach()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -166,6 +166,7 @@
 CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
 CHECK_FUNCTION_EXISTS(sysctl HAVE_SYSCTL)
 CHECK_FUNCTION_EXISTS(sysctlbyname HAVE_SYSCTLBYNAME)
+CHECK_FUNCTION_EXISTS(arc4random_uniform HAVE_ARC4RANDOM_UNIFORM)
 
 # perl -e 'do { s/\.|\//_/g; $_=uc $_;  print "#cmakedefine HAVE_$_\n"} for @ARGV' `cat headersDa`
 # perl -e 'do {my $orig=$_; s/\.|\//_/g; $_=uc $_; print "CHECK_INCLUDE_FILE_CXX($orig HAVE_$_)\n"} for @ARGV' `cat headersDa`
@@ -327,5 +328,3 @@
 
 option(HAVE_XRES "Define to enable XRes support" on)
 if(HAVE_XRES)
-    pkg_check_modules(xres xres>=1.2)
-    IF(NOT xres_FOUND)

=== debian/changelog ===
icewm (3.8.2-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Tue, 12 Aug 2025 19:19:23 +0200

## icewm 3.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
CMAKE_POLICY (SET CMP0053 NEW)
PROJECT(ICEWM CXX)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})

include(CTest)

set(PROJECT_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR})

IF(NOT DEFINED(CMAKE_INSTALL_PREFIX))
set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE STRING "Target file space")
ENDIF()
# iiieh, neeing to add some guards, since having this nested construct
# interacts badly when changing a variable afterwards cmake also insists on
# overwritting that variables later :-( if not protected
IF(NOT DEFINED(DATADIR))
set(DATADIR "${CMAKE_INSTALL_PREFIX}/share" CACHE STRING "Shared data files directory")
ENDIF()
IF(NOT DEFINED(LIBDIR))
	set(LIBDIR "${DATADIR}/icewm" CACHE STRING "Location of icewm meta data")
ENDIF()
IF(NOT DEFINED(DOCDIR))
	set(DOCDIR "${DATADIR}/doc/icewm" CACHE STRING "Location of documentation files")
ENDIF()
IF(NOT DEFINED(LOCDIR))
	set(LOCDIR "${DATADIR}/locale" CACHE STRING "System locale data directory")
ENDIF()
IF(NOT DEFINED(CFGDIR))
	set(CFGDIR "${CMAKE_INSTALL_PREFIX}/etc/icewm" CACHE STRING "Location of system-wide configuration files")
ENDIF()
IF(NOT DEFINED(ICEHELPIDX))
	set(ICEHELPIDX "${DOCDIR}/icewm.html" CACHE STRING "Location of HTML manual entry page")
ENDIF()
IF(NOT DEFINED(BINDIR))
set(BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
ENDIF()

find_package(Git)
find_program(SED_EXECUTABLE sed)

if(Git_FOUND AND IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
	if(NOT DEFINED VERSION)
		execute_process(COMMAND "${GIT_EXECUTABLE}" "describe" "--tags"
			COMMAND "${SED_EXECUTABLE}" "s,[-_],.,g;s,\\.g.*$,,"
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			OUTPUT_VARIABLE VERSION
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	endif()
	if(NOT DEFINED PACKAGE)
		set(PACKAGE "icewm")
	endif()
else()
	FILE(READ "${CMAKE_SOURCE_DIR}/VERSION" vfilecontents)
	STRING(REGEX REPLACE "\n" ";" vfilecontents "${vfilecontents}")
	foreach (line ${vfilecontents})
		STRING(REGEX REPLACE "=" ";" keyval "${line}")
		list(GET keyval 0 _key)
		IF(NOT DEFINED ${_key})
			list(GET keyval 1 ${_key})
		ENDIF()
	endforeach()
endif()
set(PACKAGE_STRING ${PACKAGE})

add_subdirectory(src)
add_subdirectory(po)
add_subdirectory(lib)
add_subdirectory(doc)
add_subdirectory(man)

install(FILES icewm-set-gnomewm contrib/icewm-menu-xrandr DESTINATION ${BINDIR} PERMISSIONS WORLD_EXECUTE OWNER_EXECUTE GROUP_EXECUTE WORLD_READ OWNER_READ OWNER_WRITE GROUP_READ)

# vim: set sw=2 ts=2 noet:

=== doc/CMakeLists.txt ===
#
# The list of files which need to be converted to HTML.
#
set(MARK_FILES icewm.md)
set(ADOC_FILES icewm.adoc)

#
# The destination directory for HTML pages.
#
if(NOT HTMLDIR)
    if(ICEHELPIDX)
        get_filename_component(HTMLDIR "${ICEHELPIDX}" PATH)
    else()
        set(HTMLDIR "${DOCDIR}")
    endif()
endif()

#
# Detect input processor.
#
if(NOT MARKDOWN AND NOT ASCIIDOC)
    find_program(MARKDOWN NAMES markdown markdown_py discount-markdown Markdown.pl)
    if (NOT MARKDOWN)
        find_program(ASCIIDOC NAMES asciidoctor asciidoc)
    endif()
endif()

#
# Convert Markdown pages to HTML.
#
if(MARKDOWN)
    set(HTML_OUTPUT_FILES)
    foreach(mark ${MARK_FILES})
        string(REGEX REPLACE \\.md$ .html htm ${mark})
        set(txt "${CMAKE_SOURCE_DIR}/doc/${mark}")
        set(out "${CMAKE_BINARY_DIR}/${htm}")
        ADD_CUSTOM_COMMAND(OUTPUT "${out}"
            COMMAND ${MARKDOWN} "${txt}" > "${out}"
            DEPENDS "${txt}"
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )
        list(APPEND HTML_OUTPUT_FILES "${out}")
    endforeach()
    ADD_CUSTOM_TARGET(build_html_docs ALL DEPENDS ${HTML_OUTPUT_FILES})

#
# Convert AsciiDoc pages to HTML.
#
elseif(ASCIIDOC)
    if(NOT ASCIIDOC_BACKEND)
        if(ASCIIDOC MATCHES asciidoctor$)
            set(ASCIIDOC_BACKEND --backend=html5)
        elseif(ASCIIDOC MATCHES asciidoc$)
            set(ASCIIDOC_BACKEND --backend=html4)
        endif()
    endif()

    set(HTML_OUTPUT_FILES)
    foreach(adoc ${ADOC_FILES})
        string(REGEX REPLACE \\.adoc$ .html htm ${adoc})
        set(txt "${CMAKE_SOURCE_DIR}/doc/${adoc}")
        set(out "${CMAKE_BINARY_DIR}/${htm}")
        ADD_CUSTOM_COMMAND(OUTPUT "${out}"
            COMMAND ${ASCIIDOC} ${ASCIIDOC_BACKEND} -o "${out}" "${txt}"
            DEPENDS "${txt}"
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )
        list(APPEND HTML_OUTPUT_FILES "${out}")
    endforeach()
    ADD_CUSTOM_TARGET(build_html_docs ALL DEPENDS ${HTML_OUTPUT_FILES})

else()
    message(WARNING "markdown and asciidoctor not found.\n"
            "NOT regenerating HTML documentation.\n"
            "To rebuild install markdown or asciidoctor.")
    FILE(GLOB HTML_OUTPUT_FILES *.html)
endif()

#
# Install HTML pages.
#
foreach(html ${HTML_OUTPUT_FILES})
    install(FILES "${html}" DESTINATION "${HTMLDIR}")
endforeach()
message(STATUS "HTMLDIR => ${HTMLDIR}")

=== man/CMakeLists.txt ===
#
# The destination directory for manpages.
#
if(NOT MANDIR)
    set(MANDIR ${DATADIR}/man)
endif()

#
# The destination directory for HTML pages.
#
if(NOT HTMLDIR)
    if(ICEHELPIDX)
        get_filename_component(HTMLDIR ${ICEHELPIDX} PATH)
    else()
        set(HTMLDIR ${DOCDIR})
    endif()
endif()

#
# Convert .pod to manpage.
#
macro(Pod2Man name sectionId sectionName)
    string(REGEX REPLACE "\\.man$" ".pod" podName "${name}")
    string(REGEX REPLACE "\\.man$" ".${sectionId}" manName "${name}")
    ADD_CUSTOM_COMMAND(
        COMMENT "Convert ${podName} to ${manName}."
        OUTPUT ${manName}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${podName}
        COMMAND pod2man ARGS
        --center=${sectionName}
        --errors="none"
        --fixed="CW"
        --fixedbold="CB"
        --fixeditalic="CI"
        --fixedbolditalic="CX"
        --nourls
        --release="${PACKAGE} ${VERSION}"
        --section="${sectionId}"
        ${CMAKE_CURRENT_SOURCE_DIR}/${podName} ${manName}
        COMMAND sed ARGS -i.bak -r
        -e 's,\([^a-z/]\)/usr/share/icewm,\\1${LIBDIR},'
        -e 's,\([^a-z/]\)/etc/icewm,\\1${CFGDIR},'
        -e 's,\([^A-Z/]\)CFGDIR/,\\1${CFGDIR}/,g'
        -e 's,\([^A-Z/]\)LIBDIR/,\\1${LIBDIR}/,g'
        -e 's,\@CFGDIR\@,${CFGDIR},g'
        ${manName}
        COMMAND rm -f -- ${manName}.bak
        )
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${manName}
            DESTINATION ${MANDIR}/man${sectionId})
    list(APPEND MAN_RESULTS ${manName})
endmacro()

#
# Convert .pod to html.
#
macro(Pod2Html name sectionId sectionName)
    string(REGEX REPLACE "\\.man$" ".pod" podName "${name}")
    string(REGEX REPLACE "\\.man$" ".${sectionId}.html" htmlName "${name}")
    ADD_CUSTOM_COMMAND(
        COMMENT "Convert ${podName} to ${htmlName}."
        OUTPUT ${htmlName}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${podName}
        COMMAND pod2html ARGS
        --title=${sectionName}
        --backlink
        --header
        --poderrors
        --podroot=${CMAKE_CURRENT_SOURCE_DIR}
        --podpath=man
        --htmldir=${HTMLDIR}
        --noindex
        --infile=${CMAKE_CURRENT_SOURCE_DIR}/${podName}
        --outfile=${htmlName}
        --quiet
        COMMAND sed ARGS -i.bak -r
        -e 's,http://man.he.net/man\(.\)/\(ice[^\"]*\),\\2.\\1.html,g'
        -e 's,man.he.net/man\(.\)/\([^\"]*\),manned.org/\\2.\\1,g'
        -e 's,\([^a-z/]\)/usr/share/icewm,\\1${LIBDIR},'
        -e 's,\([^a-z/]\)/etc/icewm,\\1${CFGDIR},'
        -e 's,\([^A-Z/]\)CFGDIR/,\\1${CFGDIR}/,g'
        -e 's,\([^A-Z/]\)LIBDIR/,\\1${LIBDIR}/,g'
        -e 's,\@CFGDIR\@,${CFGDIR},g'
        -e 's,<h1,<h2,g'
        -e 's,h1>,h2>,g'
        -e 's,http:,https:,g' ${htmlName}
        COMMAND rm -f -- ${htmlName}.bak
        )
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${htmlName}
            DESTINATION ${HTMLDIR})
    list(APPEND HTML_RESULTS ${htmlName})
endmacro()

set(icewm_man1_files
    icehelp.man
    icesh.man
    icesound.man
    icewm-menu-xrandr.man
    icewm-session.man
    icewm-set-gnomewm.man
    icewm.man
    icewmbg.man
    icewmhint.man
)

if(CONFIG_EXTERNAL_SYSTRAY)
    list(APPEND icewm_man1_files icewmtray.man)
endif()
if(CONFIG_FDO_MENUS)
    list(APPEND icewm_man1_files icewm-menu-fdo.man)
endif()

set(icewm_man5_files
    icewm-env.man
    icewm-focus_mode.man
    icewm-keys.man
    icewm-menu.man
    icewm-preferences.man
    icewm-prefoverride.man
    icewm-programs.man
    icewm-shutdown.man
    icewm-startup.man
    icewm-theme.man
    icewm-toolbar.man
    icewm-winoptions.man
)

foreach(x ${icewm_man1_files})
        Pod2Man(${x} 1 "User Commands")
        Pod2Html(${x} 1 "User Commands")
endforeach()

foreach(x ${icewm_man5_files})
        Pod2Man(${x} 5 "Standards, Environments and Macros")
        Pod2Html(${x} 5 "Standards, Environments and Macros")
endforeach()

ADD_CUSTOM_TARGET(manpages ALL DEPENDS ${MAN_RESULTS} ${HTML_RESULTS})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -110,7 +110,7 @@
 option(CONFIG_GDK_PIXBUF_XLIB "GDK-PIXBUF image loader" off)
 option(CONFIG_LIBRSVG "Support SVG icons using librsvg" off)
 option(CONFIG_NANOSVG "Support SVG icons using nanosvg" off)
-option(CONFIG_XPM "XPM image loader" on)
+option(CONFIG_XPM "XPM image loader" off)
 option(CONFIG_I18N "Define to enable internationalization" on)
 option(CONFIG_XRANDR "Define to enable XRANDR extension" on)
 option(CONFIG_SESSION "Define to enable X session management" on)
@@ -183,6 +183,7 @@
 pkg_check_modules(fontconfig fontconfig)
 pkg_check_modules(xrender REQUIRED xrender)
 pkg_check_modules(xcomposite REQUIRED xcomposite)
+pkg_check_modules(xcursor REQUIRED xcursor)
 pkg_check_modules(xdamage REQUIRED xdamage)
 pkg_check_modules(xfixes REQUIRED xfixes)
 pkg_check_modules(xext REQUIRED xext)
@@ -190,15 +191,11 @@
 
 CHECK_LIBRARY_EXISTS(X11 XInternAtoms ${x11_LIBDIR} HAVE_XINTERNATOMS)
 
-set(icewm_img_libs ${xrender_LDFLAGS} ${xcomposite_LDFLAGS} ${xdamage_LDFLAGS} ${xfixes_LDFLAGS})
+set(icewm_img_libs ${xrender_LDFLAGS} ${xcomposite_LDFLAGS}
+                   ${xcursor_LDFLAGS} ${xdamage_LDFLAGS} ${xfixes_LDFLAGS})
 
 # It would be a good idea to use different names for the image options and do the
 # logics here.  For now, this self-adapting code modifies the option variables.
-
-set(HINT_CURSORS
-[=[
- Cursor support requires either -DCONFIG_XPM=on or -DCONFIG_IMLIB2=on.
-]=])
 
 set(HINT_IMG_LOADERS
 [=[
@@ -208,7 +205,7 @@
  or else 'yximage' must be enabled by -DCONFIG_LIBPNG=on.
  The latter requires -DCONFIG_XPM=on, while -DCONFIG_LIBJPEG=on is recommended.
  Support SVG icons with either -DCONFIG_LIBRSVG=on or -DCONFIG_NANOSVG=on.
- ]=] ${HINT_CURSORS})
+ ]=])
 
 # image configuration error check
 if(CONFIG_IMLIB2 OR CONFIG_GDK_PIXBUF_XLIB)
@@ -279,15 +276,6 @@
     endforeach()
 endif()
 
-# cursor configuration error check
-if(CONFIG_XPM)
-    #ok
-elseif(CONFIG_IMLIB2)
-    #ok
-else()
-    MESSAGE(FATAL_ERROR ${HINT_CURSORS})
-endif()
-
 if(CONFIG_XPM)
     pkg_check_or_fail(libxpm xpm "XPM image loader selected but libXpm dev files not found."
         ${HINT_IMG_LOADERS})
@@ -328,3 +316,8 @@
 
 option(HAVE_XRES "Define to enable XRes support" on)
 if(HAVE_XRES)
+    pkg_check_modules(xres xres>=1.2)
+    IF(NOT xres_FOUND)
+        message(WARNING "xres library (>=1.2) not found, disabling HAVE_XRES")
+        set(HAVE_XRES off)
+    ELSE()

=== debian/changelog ===
icewm (3.9.0-2) unstable; urgency=low

  * Updating build-deps with latest xorg-dev dependencies list, to prevent
    future and current FTBFS (closes: #1116587, #1119646)

 -- Eduard Bloch <blade@debian.org>  Fri, 07 Nov 2025 19:59:20 +0100

icewm (3.9.0-1) unstable; urgency=low

  * New upstream release
    + cherry-picking trivial bugfixes from upstream branch

 -- Eduard Bloch <blade@debian.org>  Sun, 28 Sep 2025 12:41:51 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
 Build-Depends: debhelper (>= 10),
-# misc. build tools
+# misc, build tools
   gettext,
   pandoc (>> 2),
   cmake (>> 3.12),
   asciidoctor,
+  libfribidi-dev,
   dpkg-dev (>= 1.16.1~),
 # sound libs
   libsndfile1-dev,
@@ -17,18 +18,8 @@
   libnanosvg-dev,
 # font processor(s)
   libxft-dev (>> 2.1.1) | libxft2-dev,
-# X11 libs
-  x11proto-core-dev | x-dev,
-  libsm-dev,
-  libx11-dev,
-  libxext-dev,
-  libxinerama-dev,
-  libxrender-dev,
-  libxrandr-dev,
-  libfribidi-dev,
-  libxcomposite-dev,
-  libxdamage-dev,
-  libxres-dev
+# X11 libs - since we are not allowed to use the meta package
+  libfontenc-dev, libfs-dev, libice-dev, libsm-dev, libx11-dev, libxau-dev, libxaw7-dev, libxcomposite-dev, libxcursor-dev, libxdamage-dev, libxdmcp-dev, libxext-dev, libxfixes-dev, libxfont-dev, libxft-dev, libxi-dev, libxinerama-dev, libxkbfile-dev, libxmu-dev, libxmuu-dev, libxpm-dev, libxrandr-dev, libxrender-dev, libxres-dev, libxss-dev, libxt-dev, libxtst-dev, libxv-dev, libxvmc-dev, libxxf86dga-dev, libxxf86vm-dev, x11proto-dev, xserver-xorg-dev, xtrans-dev
 Build-Conflicts: libttf-dev, libesd0-dev
 Standards-Version: 4.5.0
 Vcs-Git: https://github.com/Code7R/icewm.git

## icewm 4.0.0

=== po/CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,7 @@
 find_program(msgfmt msgfmt)
 
 set(COPYRIGHT_HOLDER "Marko Macek <Marko.Macek@gmx.net>")
-set(BUG_ADDRESS "https://github.com/bbidulock/icewm/issues")
+set(BUG_ADDRESS "https://github.com/ice-wm/icewm/issues")
 
 if(NOT gettext OR NOT xgettext OR NOT msgmerge OR NOT msgfmt)
     message(STATUS "Some of those tools not found, skipping translations! gettext, xgettext, msgmerge, msgfmt")

=== debian/changelog ===
icewm (4.0.0-1) unstable; urgency=low

  * New upstream release
    + cherry-picked CMake warning fix from pending MR

 -- Eduard Bloch <blade@debian.org>  Sun, 18 Jan 2026 22:49:03 +0100
